#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivityKingCraftExchange.h"
std::auto_ptr<M_ActivityKingCraftExchange> M_ActivityKingCraftExchange::msSingleton(nullptr);

int M_ActivityKingCraftExchange::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivityKingCraftExchangeData* M_ActivityKingCraftExchange::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivityKingCraftExchangeData>& M_ActivityKingCraftExchange::GetMapData()
{
	return mMapData;
}

void M_ActivityKingCraftExchange::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivityKingCraftExchange.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivityKingCraftExchangeData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mNeedItem = element->IntAttribute("NeedItem");
		data.mNeedCount = element->IntAttribute("NeedCount");
		data.mItemID = element->IntAttribute("ItemID");
		data.mItemCount = element->IntAttribute("ItemCount");
		data.mLimit = element->IntAttribute("Limit");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivityKingCraftExchange Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityKingCraftExchange::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivityKingCraftExchange");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivityKingCraftExchange");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivityKingCraftExchangeData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "NeedItem", data.mNeedItem);
		LuaCfgHelper::readInt(L, "NeedCount", data.mNeedCount);
		LuaCfgHelper::readInt(L, "ItemID", data.mItemID);
		LuaCfgHelper::readInt(L, "ItemCount", data.mItemCount);
		LuaCfgHelper::readInt(L, "Limit", data.mLimit);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivityKingCraftExchange Loaded. Load Data:%u", mMapData.size());
}

void M_ActivityKingCraftExchange::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivityKingCraftExchange* M_ActivityKingCraftExchange::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivityKingCraftExchange());
	}
	return msSingleton.get();
}

void M_ActivityKingCraftExchange::Release()
{
	msSingleton.reset(nullptr);
}
